////////////////////////////////////////////////////////////////////////////////
// auls_aliaslist.cpp
// GCAXꗗ\vOC
////////////////////////////////////////////////////////////////////////////////

#include <aulslib/aviutl.h>
#include <aulslib/exedit.h>
#include <aulslib/memref.h>
#include <yulib/window.h>

using namespace yulib;
using namespace auls;

LPSTR FILTER_NAME = "GCAXꗗ";
LPSTR FILTER_INFORMATION = "AulsGCAXꗗ";

static const int ALIAS_LIST_ID = 4000;
static const int WINDOW_HEIGHT_ADD = 300;
static const int ALIAS_LIST_MARGIN = 3;
LPSTR g_alias_name;

yulib::CListBox g_alias_list;
int g_alias_top;

HWND g_aviutl_hwnd;
HWND g_exedit_hwnd;
HWND g_objdlg_hwnd;

static void InitAliasList(CListBox *list)
{
	int sel = list->GetCurSel();

	list->SetRedraw(FALSE);
	list->ResetContent();
	LPSTR ptr = g_alias_name;
	while(*ptr) {
		if(*ptr == '\\') ptr++;
		list->AddString(ptr);
		while(*ptr) ptr++;
		ptr++;
	}
	list->SetCurSel(sel);
	list->SetRedraw(TRUE);
}

static void PutAlias(HWND hwnd, int id)
{
	SendMessage(hwnd, WM_COMMAND, EXEDIT_ALIAS_ID_BEGIN + id, 0);
}


static BOOL func_init(FILTER *fp)
{
	g_exedit_hwnd = auls::Exedit_GetWindow(fp);
	if(!g_exedit_hwnd) return FALSE;

	g_aviutl_hwnd = GetWindow(g_exedit_hwnd, GW_OWNER);

	// GCAXobt@̃|C^擾
	auls::CMemref memref;
	if(!memref.Init(fp)) goto memref_failure;
	g_alias_name = memref.Exedit_AliasNameBuffer();
	if(!g_alias_name) goto memref_failure;

	if(0) { memref_failure:
		MessageBox(fp->hwnd, memref.GetErrorString(), FILTER_INFORMATION, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	RECT cr;
	GetClientRect(fp->hwnd, &cr);
	if(!g_alias_list.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_BORDER | LBS_NOTIFY,
		0,
		ALIAS_LIST_MARGIN, cr.bottom - WINDOW_HEIGHT_ADD, cr.right - cr.left - ALIAS_LIST_MARGIN*2, WINDOW_HEIGHT_ADD,
		fp->hwnd, ALIAS_LIST_ID, fp->dll_hinst)) {
			return FALSE;
	}

	g_alias_list.SetFont(auls::AviUtl_GetFilterWindowFont(fp));

	return TRUE;
}

static BOOL func_WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp, void *editp, FILTER *fp)
{
	switch(msg) {
		case WM_COMMAND:
			switch(LOWORD(wp)) {
				case MID_FILTER_BUTTON+0:
					SetFocus(hwnd);
					PutAlias(g_exedit_hwnd, g_alias_list.GetCurSel());
					break;
				case MID_FILTER_BUTTON+1:
					SetFocus(hwnd);
					PutAlias(g_objdlg_hwnd, g_alias_list.GetCurSel());
					break;
				case MID_FILTER_BUTTON+2:
					SetFocus(hwnd);
					InitAliasList(&g_alias_list);
					break;
				case ALIAS_LIST_ID:
					if(HIWORD(wp) == LBN_DBLCLK) PutAlias(fp->check[3] ? g_exedit_hwnd : g_objdlg_hwnd, g_alias_list.GetCurSel());
					break;
			}
			break;
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			SendMessage(g_aviutl_hwnd, msg, wp, lp);
			break;
		case WM_FILTER_CHANGE_WINDOW:
			if(!g_objdlg_hwnd) {
				g_objdlg_hwnd = auls::ObjDlg_GetWindow(g_exedit_hwnd);
				InitAliasList(&g_alias_list);
				g_alias_list.SetCurSel(0);
			}
			break;
	}

	return FALSE;
}

LPSTR check_name[] = { "IGCAX^CCɔzu", "IGCAXIuWFNgɒǉ", "GCAXꗗ̍XV", "Xg_uNbNTLɔzu" };
int   check_def[]  = { -1, -1, -1, 1 };

static FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE | FILTER_FLAG_WINDOW_SIZE | FILTER_FLAG_EX_INFORMATION,
	FILTER_WINDOW_SIZE_ADD+0, FILTER_WINDOW_SIZE_ADD + WINDOW_HEIGHT_ADD,
	FILTER_NAME,
	0, NULL, NULL, NULL, NULL,
	sizeof(check_name) / sizeof(*check_name), check_name, check_def,
	NULL,
	func_init,
	NULL,
	NULL,
	func_WndProc,
	NULL,
	NULL,
	NULL,
	NULL,
	FILTER_INFORMATION,
};

extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}
